/********************************************************************
* Copyright (c) 2010, Visual Computing Center(VCC), ShenZhen Institute
* of Advanced Technology, Chinese Academy of Sciences. Liangliang Nan, 
* all rights reserved.	
*
*   created:	2006/04/27
*	filename: 	ArcBall.h
*	author:		Liangliang Nan
*   E-mail:     liangliang.nan@gmail.com
*	purpose:	ArcBall for convenient rotation 
*
*********************************************************************/



#ifndef _ARC_BALL_H_
#define _ARC_BALL_H_

#include <cmath>
#include "ArcballMath.h"


class Arcball
{	
public:	
	void reshape(float ptMouseX, float ptMouseY);		// Set mouse bounds.
	void mouse_down(float ptMouseX, float ptMouseY);	// Starting rotation. Called when mouse pressed.
	void mouse_move(float ptMouseX, float ptMouseY);	// Drag and move the mouse. Called when mouse move.
	void apply_rotation();							// Apply dynamic transform. Called when render scene.
	void reset_rotation();							// Reset rotation.

public:
	// ¼ĳһת״̬
	void Copy(Arcball* arcBall) const;
	void Set(const Arcball* arcBall);

public:
	Arcball();
	~Arcball();

private:
	 void map_to_sphere(float x, float y, float* vecNew) const;
	
private:
	float    mbWidth;		   // Mouse bounds width
	float    mbHeight;	       // Mouse bounds height

	float    vecClick[3];      // Saved click vector
	float    vecDrag[3];       // Saved drag vector

 	Matrix33   lastRot;		   // Last rotation	
 	Matrix33   thisRot;		   // This rotation 
	Matrix44   transform;      // Final transform
} ;


#endif

